Logo Questions Linux Laravel Mysql Ubuntu Git Menu
 

Aborting a shell script if any command returns a non-zero value

I have a Bash shell script that invokes a number of commands.

I would like to have the shell script automatically exit with a return value of 1 if any of the commands return a non-zero value.

Is this possible without explicitly checking the result of each command?

For example,

dosomething1 if [[ $? -ne 0 ]]; then     exit 1 fi  dosomething2 if [[ $? -ne 0 ]]; then     exit 1 fi 
like image 776
Jin Kim Avatar asked May 04 '09 18:05

Jin Kim


People also ask

How do you terminate a shell script?

To end a shell script and set its exit status, use the exit command. Give exit the exit status that your script should have. If it has no explicit status, it will exit with the status of the last command run.

How do you exit a script if command fails?

Exit When Any Command Fails This can actually be done with a single line using the set builtin command with the -e option. Putting this at the top of a bash script will cause the script to exit if any commands return a non-zero exit code.

What is $@ and $* in shell script?

"$@" Stores all the arguments that were entered on the command line, individually quoted ("$1" "$2" ...). So basically, $# is a number of arguments given when your script was executed. $* is a string containing all arguments. For example, $1 is the first argument and so on.

What is $? == 0 in shell script?

$? is the exit status of the most recently-executed command; by convention, 0 means success and anything else indicates failure. That line is testing whether the grep command succeeded.


Video Answer


1 Answers

Add this to the beginning of the script:

set -e 

This will cause the shell to exit immediately if a simple command exits with a nonzero exit value. A simple command is any command not part of an if, while, or until test, or part of an && or || list.

See the bash(1) man page on the "set" internal command for more details.

I personally start almost all shell scripts with "set -e". It's really annoying to have a script stubbornly continue when something fails in the middle and breaks assumptions for the rest of the script.

like image 99
Ville Laurikari Avatar answered Oct 20 '22 22:10

Ville Laurikari